#import "AppDelegate.h"


@implementation AppDelegate

- (void)awakeFromNib;
{
	// Initialize the queue
	operationQueue = [[NSOperationQueue alloc] init];
}
 
- (IBAction)grab:(id)sender;
{
	NSString *path = [outputPath stringValue];
	if( !path || [path length] <= 0 )
	{
			NSAlert *alert = [NSAlert alertWithMessageText:@"Set Output Directory" defaultButton:@"OK" alternateButton:nil otherButton:nil informativeTextWithFormat:@"You must first select an output directory before grabbing images."];
 
			[alert beginSheetModalForWindow:window
							  modalDelegate:self
							 didEndSelector:nil
								contextInfo:NULL];
			
			return;
	}
    // Check to see if the movie is playing	
    if( [[movieView movie] rate] > 0.0f )
    {
        // If so, create our NSOperation derived object and hand it off to the queue
        GrabQTImageOperation *op = [[GrabQTImageOperation alloc] init];
        [op setMovie:imagesMovie];
        [op setTime:[[movieView movie] currentTime]];
        [op setOutputPath:path];

        // As soon as this method finishes, the operation is set to work
        [operationQueue addOperation:op];
    }
}
 
- (IBAction)openMovie:(id)sender;
{
	NSOpenPanel *openPanel;
	
	openPanel = [NSOpenPanel openPanel];
    [openPanel setCanChooseDirectories:NO];
    [openPanel setAllowsMultipleSelection:NO];
    [openPanel setResolvesAliases:YES];
    [openPanel setCanChooseFiles:YES];
	
    if ([openPanel runModalForTypes:nil] == NSOKButton)
	{
		NSArray		    *filesToOpen = [openPanel filenames];
		NSString	    *theFilePath = [filesToOpen objectAtIndex:0];
		QTMovie *movie = [QTMovie movieWithFile:theFilePath error:nil];
		imagesMovie = [QTMovie movieWithFile:theFilePath error:nil];
		[imagesMovie retain];
		[movieView setMovie:movie];		
	}
}
 
- (IBAction)selectOutputDir:(id)sender;
{
	NSOpenPanel *openPanel;
	
	openPanel = [NSOpenPanel openPanel];
    [openPanel setCanChooseDirectories:YES];
    [openPanel setAllowsMultipleSelection:NO];
    [openPanel setResolvesAliases:YES];
    [openPanel setCanChooseFiles:NO];
	
    if ([openPanel runModalForTypes:nil] == NSOKButton)
	{
		NSString		*directory = [openPanel directory];
		[outputPath setStringValue:directory];
	}
}
 
- (void)dealloc;
{
	[super dealloc];
	if( imagesMovie )
		[imagesMovie release];
}
 
@end
