#import "GrabQTImageOperation.h"


@implementation GrabQTImageOperation

@synthesize movie;
@synthesize time;
@synthesize outputPath;

- (id)init;
{
	lock = [[NSLock alloc] init];
	imageAttrs = [NSDictionary dictionaryWithObjectsAndKeys:
                       QTMovieFrameImageTypeNSImage, QTMovieFrameImageType,
                       [NSNumber numberWithBool:YES], QTMovieFrameImageHighQuality, nil];
	[imageAttrs retain];
	[super init];
	return self;
}

- (void)main;
{
	if( movie )
	{
		NSImage* image;
		[lock lock];
		image = [movie frameImageAtTime:time withAttributes:imageAttrs error:nil];
		[lock unlock];
		[self saveImage:image];
	}
}

- (void)saveImage:(NSImage*)image;
{
	NSArray *representations;
	NSData *bitmapData;

	representations = [image representations];

	bitmapData = [NSBitmapImageRep representationOfImageRepsInArray:representations 
            usingType:NSJPEGFileType 
            properties:[NSDictionary dictionaryWithObject:[NSDecimalNumber numberWithFloat:1.0] 
                                                   forKey:NSImageCompressionFactor]];

	// Creates a long filename, but at least it's unique.
	NSString *filename = [[NSProcessInfo processInfo] globallyUniqueString];
	filename = [filename stringByAppendingString:@".jpg"];
	NSString *imgOut = [outputPath stringByAppendingString:@"/"];
	imgOut = [imgOut stringByAppendingString:filename];
	[bitmapData writeToFile:imgOut  atomically:YES];
}

@end
